do	-- graphics
	local ni = function(i) return love.graphics.newImage("graphics/"..i..".png") end

	graphics = {
		tiles=ni"tiles",
		terminator=ni"terminator1",
		--civ=ni"civ",
		punk=ni"punk1",
		debris=ni"debris",
	}
	local function pixel(t)
		for k,v in pairs(t) do
			if type(v)=="table" then pixel(v)
			elseif v:type()=="Image" then v:setFilter("nearest","nearest")	--"linear"
			end
		end
	end
	pixel(graphics)
end

do	-- test map
	materials = {
		{},		-- dirt
		{},		-- floor
		{resist=.04, debrisRate=1.4},		-- concrete
		{resist=.7, debrisRate=5},		-- glass
	}
	
	--local niltable = setmetatable( {}, {__index=function() return niltable end, __newindex=function() end} )
	map = setmetatable( {
		damage = setmetatable({}, { __index = function(t,k) return rawget(t,k) or
			setmetatable({}, {__index=function() return 0 end}) end }
		),
		ground = 2,		-- index of last ground tile type
		debris = love.graphics.newSpriteBatch(graphics.debris, 2000),
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,2,2,2,2,2,2,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,2,2,2,2,2,2,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,3,3,2,2,3,3,3,3,3,1,1,1,1,1},
		{1,1,1,1,1,3,2,2,2,2,3,2,2,3,1,1,1,1,1},
		{1,1,1,1,1,4,2,2,2,2,3,2,2,4,1,1,1,1,1},
		{1,1,1,1,1,4,2,2,2,2,3,2,2,3,1,1,1,1,1},
		{1,1,1,1,1,3,2,2,2,2,2,2,2,3,1,1,1,1,1},
		{1,1,1,1,1,3,3,2,3,3,3,3,2,3,1,1,1,1,1},
		{1,1,1,1,1,3,2,2,2,2,2,2,2,3,1,1,1,1,1},
		{1,1,1,1,1,4,2,2,2,2,2,2,2,3,1,1,1,1,1},
		{1,1,1,1,1,3,2,2,2,2,2,2,2,3,1,1,1,1,1},
		{1,1,1,1,1,3,3,4,4,4,4,3,2,3,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	}, { __index = function(t,k) return rawget(t,k) or {} end } )
	for x=1,#map do for y=1,#map[x] do
		local d = math.random()
		if map[x][y] > map.ground then d=d^2 else d = d*1.1 end
		if d > .34 then
			if not rawget(map.damage, x) then map.damage[x] = {} end
			map.damage[x][y] = math.min(math.round(d,1),1)
		end
	end end
	-- todo: basic map generator
end