-- Returns the distance between two points.
function math.dist(x1,y1, x2,y2) return ((x2-x1)^2+(y2-y1)^2)^0.5 end

-- Clamps a number to within a certain range.
function math.clamp(low, n, high) return math.min(math.max(low, n), high) end

-- Normalizes two numbers.
function math.normalize(x,y) local l=(x*x+y*y)^.5 if l==0 then return 0,0,0 else return x/l,y/l,l end end

-- Returns 'n' rounded to the nearest 'deci'th.
function math.round(n, deci) deci = 10^(deci or 0) return math.floor(n*deci+.5)/deci end




-- Debug message displayer.
local dmessagesMT={} function dmessagesMT.__index(t,k) local auto=setmetatable({},dmessagesMT) rawset(t,k,auto) return auto end D=setmetatable({},dmessagesMT)	-- "always make tables" metatable
function drawdmessages() D.FPS=love.timer.getFPS() local x,y, lgprint = 8,4, love.graphics.print
	local function showmessage(t) for k, v in pairs(t) do
		if type(v) ~= "function" and type(v) ~= "userdata" then
			if type(v) == "table" then lgprint(tostring(k).." -", x,y) local xm=string.len(k)*7+19 x=x+xm showmessage(v) x=x-xm
			else lgprint(tostring(k)..": "..tostring(v), x,y) end y = y+14
		end
	end end showmessage(D)
end